;----- knight5 (KNIGHT RIDER LED ver.2) -----
;      by I.N. -----
;gpfoCXFPIC16F648A
;U[hFInternal 4MHz

;2007/12/11 ver.1.0 mF

;---ړx---
; i傫lxj͈:1-255
CNTMOV0	equ 14

;---c---
; i傫lj͈:1-255
CNTZAN0	equ 5

;<ӉH>
;RB0`RB7 :LED(Cathode), Anode of LED connects to Vdd.
;~MCLR    :Vdd
;Vdd      :3V battery
;Vss      :GND

	;RtBO[V(0x3F10)
	; FOSC  = INTOSC_GPIO
	; WDTE  = Disable
	; PWRTE = Enable
	; MCLRE = Internal
	; BODEN = Disable
	; LVP   = RB4:GPIO
	; CPD   = Not_Protect
	; CP    = Not_Protect

	;Ƃ肠16F84[hŃAZu
	INCLUDE 16F84.H
	;ȉ͉ݒ
	.OSC	HS
	.PWRT	ON
	.WDT	OFF
	.PROTECT OFF

	;Start address of general purpose register (16F648A)
	ORG	20H

;V[1:I[vjO@҂
;V[2:I[vjO@tF[hC
;V[3:I[vjO@S_
;V[4:I[vjO@NXtF[h
;V[5:ʏړ

;eV[̒x(傫l, 0:)
L1TIME	equ 3
L2TIME	equ 3
L3TIME	equ 3
L4TIME	equ 5
L5TIME	equ 0

;邳x̍ől
LUMIMAX	equ 15

;^C}荞݂̎
TMR0ORG	equ 0D8h

;LED|[go͒li[p
LEDOUT	DS 1

;LED邳x(0=ScLUMIMAX=S_)
LUMI0	DS 1
LUMI1	DS 1
LUMI2	DS 1
LUMI3	DS 1
LUMI4	DS 1
LUMI5	DS 1
LUMI6	DS 1
LUMI7	DS 1

;LUMIx̏Ɖ
LUMIH	ds 1
LUMIL	ds 1

;LED邳x(荞݃[`gp)
_LUMI0	DS 1
_LUMI1	DS 1
_LUMI2	DS 1
_LUMI3	DS 1
_LUMI4	DS 1
_LUMI5	DS 1
_LUMI6	DS 1
_LUMI7	DS 1

;PWMJEgp
CNTPWM	ds 1

;Ɨp
WW	ds 1

;荞ݎ̃WX^Ҕ
W_TEMP	ds 1
S_TEMP	ds 1

;ǂ̈ʒuLED_邩̌ݒl(1-8)
POS	ds 1

;bit0:̕(1=vX, 0=}CiX)
DIR	ds 1
DIRFLG	equ DIR.0

;LEDړ܂ł̎
CNTMOV	ds 1

;邳xP܂ł̎ԁicԁj
CNTZAN	ds 1

;V[ԍ(0:None 1:Fadein 2:Hold 3:Fadeout 4:Normal)
SCENE	ds 1
;V[JE^iOɂȂƃV[Ij
SCNCNT	ds 1
;ᑬJE^p
LOWCNT		ds 1
;LOWCNT̃S[(0=)
LOWCNTMAX	ds 1
;tO
SCNFLG	ds 1
SCNFLG_LUMIHPP	equ	SCNFLG.7
SCNFLG_LUMIHMM	equ	SCNFLG.6
SCNFLG_LUMILPP	equ	SCNFLG.5
SCNFLG_LUMILMM	equ	SCNFLG.4
SCNFLG_DISP	equ	SCNFLG.0

	;X^[gxN^
	ORG	0
	GOTO START
	;荞݃xN^
	ORG	4
	goto INTR

	;PWMf[eB[i0:Â255:邢j
	;邳x0`LUMIMAXɑΉCexł̖邳`
PWMPAT	jmp PC+W
	retw 0
	retw 1
	retw 4
	retw 9
	retw 17
	retw 26
	retw 38
	retw 52
	retw 68
	retw 87
	retw 107
	retw 130
	retw 155
	retw 183
	retw 212
	retw 244

	;===== TMR0荞݃[` =====
INTR
	;荞݃tONA
	clrb T0IF

	;WX^Ҕ
	movwf W_TEMP
	swapf STATUS,W
	movwf S_TEMP

	;̊荞݂܂ł̎Ԑݒ
	mov TMR0,#TMR0ORG

	inc CNTPWM

	;---LED0---
	mov W,_LUMI0
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED1---
	mov W,_LUMI1
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED2---
	mov W,_LUMI2
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED3---
	mov W,_LUMI3
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED4---
	mov W,_LUMI4
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED5---
	mov W,_LUMI5
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED6---
	mov W,_LUMI6
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT
	;---LED7---
	mov W,_LUMI7
	call PWMPAT
	subwf CNTPWM,0
	rr LEDOUT

	;--- LEDOUT(Wrbg)|[go͂---
	mov W,LEDOUT
	mov PORTB,W

	;WX^
	swapf S_TEMP,W
	movwf STATUS
	swap W_TEMP
	swapf W_TEMP,W

	retfie
	;================================

	;--- LUMIp[^ ---
lumi_init
	clr CNTPWM
	clr LUMI0
	clr LUMI1
	clr LUMI2
	clr LUMI3
	clr LUMI4
	clr LUMI5
	clr LUMI6
	clr LUMI7
	clr _LUMI0
	clr _LUMI1
	clr _LUMI2
	clr _LUMI3
	clr _LUMI4
	clr _LUMI5
	clr _LUMI6
	clr _LUMI7
	ret

start
	;---Bank1---
	setb RP0
	; 荞݋֎~
	clrb GIE
	; |[gA(RA7..0)͏ó@RA4͓͐p
	; |[gB(RB7..0)͏o
	mov TRISA,#00h
	mov TRISB,#00h
	; vAbvȂCvXP[>TMR0
	; TMR0:NbN,vXP[1:2
	mov OPTION,#80h
	;---Bank0---
	clrb RP0

	; |[gȁ
	mov W,#0ffh
	mov PORTB,W
	mov TMR0,#TMR0ORG

	;--- ړxƎcԂݒ肷 ---
	; ړx
	mov CNTMOV,#CNTMOV0
	; c
	mov CNTZAN,#CNTZAN0

	;--- TMR0荞݋ ---
	setb T0IE
	;--- 荞݋ ---
	setb GIE

	;---scene1̃Zbg---
	call lumi_init
	; ړJnʒuƕ̏
	mov POS,#4
	mov DIR,#0
	clr LOWCNT
	mov SCENE,#1
	mov LOWCNTMAX,#L1TIME
	mov LUMIL,#0
	mov LUMIH,#0
	mov SCNFLG,#00h
	mov SCNCNT,#2

	;===== C[v =====
cont
	;\tO̔
	; \tO0Ȃc֔
	jnb SCNFLG_DISP, LZAN

	;--- LEDړ̂߂̃JE^CNTMOV̏ ---
	djnz CNTMOV,LZAN
	mov CNTMOV,#CNTMOV0
	sb DIRFLG
	jmp LMINUS
	;-- vX̏ꍇC_LEDԍ{P
	;   _LEDԍ8ɂȂCtɂ
	inc POS
	csbe POS,#7
	clrb DIRFLG
	goto set_pos
LMINUS
	;-- }CiX̏ꍇC_LEDԍ|P
	;   _LEDԍ1ɂȂCtɂ
	dec POS
	csae POS,#2
	setb DIRFLG

set_pos
	;_LEDԍ𒲂ׂāCYԍ̖邳xLUMIMAXɃZbg
SPOS1	cjne POS,#1,SPOS2
	mov LUMI0,#LUMIMAX
	jmp LZAN
SPOS2	cjne POS,#2,SPOS3
	mov LUMI1,#LUMIMAX
	jmp LZAN
SPOS3	cjne POS,#3,SPOS4
	mov LUMI2,#LUMIMAX
	jmp LZAN
SPOS4	cjne POS,#4,SPOS5
	mov LUMI3,#LUMIMAX
	jmp LZAN
SPOS5	cjne POS,#5,SPOS6
	mov LUMI4,#LUMIMAX
	jmp LZAN
SPOS6	cjne POS,#6,SPOS7
	mov LUMI5,#LUMIMAX
	jmp LZAN
SPOS7	cjne POS,#7,SPOS8
	mov LUMI6,#LUMIMAX
	jmp LZAN
SPOS8	cjne POS,#8,LZAN
	mov LUMI7,#LUMIMAX

	;c
	;cJE^CNTZAN0ɂȂ΁C邳xP
	;邳x=0̏ꍇ͉Ȃ
LZAN	djnz CNTZAN,LZANEND
	mov CNTZAN,#CNTZAN0
	test LUMI0
	sz
	dec LUMI0
	test LUMI1
	sz
	dec LUMI1
	test LUMI2
	sz
	dec LUMI2
	test LUMI3
	sz
	dec LUMI3
	test LUMI4
	sz
	dec LUMI4
	test LUMI5
	sz
	dec LUMI5
	test LUMI6
	sz
	dec LUMI6
	test LUMI7
	sz
	dec LUMI7
LZANEND

	;----- V[̏ -----
	test LOWCNTMAX
	jz skp0

	inc LOWCNT
	cjb LOWCNT,LOWCNTMAX,skp0
	clr LOWCNT
	snb SCNFLG_LUMIHPP
	inc LUMIH
	snb SCNFLG_LUMIHMM
	dec LUMIH
	snb SCNFLG_LUMILPP
	inc LUMIL
	snb SCNFLG_LUMILMM
	dec LUMIL
	dec SCNCNT
	jnz skp0

	; V[JE^0ɂȂƂ
	; ̃V[Zbg
	cje SCENE,#1,scene2
	cje SCENE,#2,scene3
	cje SCENE,#3,scene4
	cje SCENE,#4,scene5
	cje SCENE,#5,scene5
	goto skp0

scene2
	mov SCENE,#2
	mov LOWCNTMAX,#L2TIME
	mov LUMIL,#0
	mov LUMIH,#LUMIMAX
	mov SCNFLG,#20h
	mov SCNCNT,#LUMIMAX
	goto skp0

scene3
	mov SCENE,#3
	mov LOWCNTMAX,#L3TIME
	mov LUMIL,#LUMIMAX
	mov LUMIH,#LUMIMAX
	mov SCNFLG,#01h
	mov SCNCNT,#21
	goto skp0

scene4
	mov SCENE,#4
	mov LOWCNTMAX,#L4TIME
	mov LUMIL,#LUMIMAX
	mov LUMIH,#LUMIMAX
	mov SCNFLG,#11h
	mov SCNCNT,#LUMIMAX
	goto skp0

scene5
	mov SCENE,#5
	mov LOWCNTMAX,#L5TIME
	mov LUMIL,#0
	mov LUMIH,#LUMIMAX
	mov SCNFLG,#01h
	mov SCNCNT,#LUMIMAX
	goto skp0

skp0
	;--- LUMIx_LUMIxփRs[
	;    (LUMIH,LUMILɂ鐧t)
j0	cja LUMI0,LUMIH,j0a
	cjb LUMI0,LUMIL,j0b
	mov _LUMI0,LUMI0
	goto j1
j0b	mov _LUMI0,LUMIL
	goto j1
j0a	mov _LUMI0,LUMIH

j1	cja LUMI1,LUMIH,j1a
	cjb LUMI1,LUMIL,j1b
	mov _LUMI1,LUMI1
	goto j2
j1b	mov _LUMI1,LUMIL
	goto j2
j1a	mov _LUMI1,LUMIH

j2	cja LUMI2,LUMIH,j2a
	cjb LUMI2,LUMIL,j2b
	mov _LUMI2,LUMI2
	goto j3
j2b	mov _LUMI2,LUMIL
	goto j3
j2a	mov _LUMI2,LUMIH

j3	cja LUMI3,LUMIH,j3a
	cjb LUMI3,LUMIL,j3b
	mov _LUMI3,LUMI3
	goto j4
j3b	mov _LUMI3,LUMIL
	goto j4
j3a	mov _LUMI3,LUMIH

j4	cja LUMI4,LUMIH,j4a
	cjb LUMI4,LUMIL,j4b
	mov _LUMI4,LUMI4
	goto j5
j4b	mov _LUMI4,LUMIL
	goto j5
j4a	mov _LUMI4,LUMIH

j5	cja LUMI5,LUMIH,j5a
	cjb LUMI5,LUMIL,j5b
	mov _LUMI5,LUMI5
	goto j6
j5b	mov _LUMI5,LUMIL
	goto j6
j5a	mov _LUMI5,LUMIH

j6	cja LUMI6,LUMIH,j6a
	cjb LUMI6,LUMIL,j6b
	mov _LUMI6,LUMI6
	goto j7
j6b	mov _LUMI6,LUMIL
	goto j7
j6a	mov _LUMI6,LUMIH

j7	cja LUMI7,LUMIH,j7a
	cjb LUMI7,LUMIL,j7b
	mov _LUMI7,LUMI7
	goto j8
j7b	mov _LUMI7,LUMIL
	goto j8
j7a	mov _LUMI7,LUMIH

j8
	goto cont

